#include <relapp.h>
#include <stdtypes.h>
#include <lffiles.h>
#include "ba4.h"
#include "ba4600.h"

class TSoci_application : public TRelation_application
{
  TMask* _msk;
  TRelation* _rel;
  TLocalisamfile* _anag;
  TLocalisamfile* _ditte;

  bool user_create() ;                         
  bool user_destroy() ;                        
  virtual TMask* get_mask(int mode) { return _msk;}
  virtual bool changing_mask(int mode) { return FALSE;}
  virtual TRelation* get_relation() const { return _rel;}

public:
  TSoci_application() {}
  virtual ~TSoci_application() {}
  virtual void init_query_mode(TMask& m) ;
  virtual void init_query_insert_mode(TMask& m) ;
};

void TSoci_application::init_query_mode(TMask& m)

{
  m.show(FLD_SC1_CODANAGRSOH);
  m.hide(FLD_SC1_CODANAGRSO);
  m.set(FLD_SC1_CODANAGR_ANAGR_RAGSOC, "");
}


void TSoci_application::init_query_insert_mode(TMask& m)

{
  m.show(FLD_SC1_CODANAGRSO);
  m.hide(FLD_SC1_CODANAGRSOH);
  m.set(FLD_SC1_CODANAGR_ANAGR_RAGSOC, "");
}

bool TSoci_application::user_create() 
{
  _msk = new TMask("ba4600a") ;
  _rel = new TRelation(LF_SOCI) ;
  _anag = new TLocalisamfile(LF_ANAG) ;
  _ditte = new TLocalisamfile(LF_NDITTE) ;
  set_search_field(FLD_SC1_CODANAGRSOH);
  return TRUE;
}

bool TSoci_application::user_destroy() 
{
  delete _msk;
  delete _rel;
  delete _anag;
  delete _ditte;
  return TRUE;
}

int ba4600(int argc, char* argv[])
{
  TSoci_application a ;
  a.run(argc, argv, "Anagrafica Soci");
  return 0;
}
