//
// cg4400.h
// 
#include <isam.h>
#include <printapp.h>
#include <mask.h>
#include <tabutil.h>
#include <utility.h>
#include <urldefid.h>
#include <text.h>
#include <mailbox.h>
#include <execp.h>
#include <sheet.h>
#include <config.h> 
#include <prefix.h>
#include "conto.h"
#include <nditte.h>
#include <anagr.h>
#include <comuni.h>
#include <unloc.h>
#include <mov.h>
#include <rmoviva.h>
#include <clifo.h>
#include <occas.h>
#include <causali.h>

#include "cglib03.h"

const int TABREG = (int)TTable::name2log("REG");

class CG4400_application : public TPrintapp
{
  TCursor        * _cur;
  TRelation      *_rel;
  TLocalisamfile *_clifo, *_nditte, *_occas, *_tab, *_tabcom, *_com, *_anag, *_unloc, *_attiv;
  TTable         *_tabreg, *_tablbu, *_tabinl, *_tablim, *_tabpim, *_tablia, *_tabiva; 
  TTable         *_tabpla, *_tabppa, *_tabvid;
  TRigaiva_array _iva_array, _riga_rmi;
  TTipodoc_array _doc_array;     
  TRiga_array    _tot_iva_array;

  TBit_array     _selected;
  TArray_sheet   *_ditte;
  bool           _st_liq[12];   
  TRecnotype     _nrec;
  bool           _mov_empty, _stampa_ind_ditta, _stampa_tutti_i_registri, _auto_intraf, _stampa;
  bool           _corrispettivi, _liquidazione, _riep_liq, _stampa_ind_comp, _esiste_riga_iva, _stampa_cred_pre; 
  bool           _rif_vid, _intesta_vidi, _intesta_liq, _stampa_data_reg, _ok_vidi;
  char           _frequiva, _tipo_riepilogativo;
  TDate          _data_da, _data_a, _data_stampa, _dataregp, _dataregs, _datareg;
  TDate          _u_data;
  long           _n_ditte, _u_stampata, _primast, __firm, _uprotivap;
  long           _numini, _pagine_stampate;
  int            _fino_a_mese, _tipo_reg, _tipo_stampa, _cod_un_loc;
  int            _annoes, _r, _stampa_width, _mese_ultima_liq, _mese_credito; 
  int            _stampa_len, _stampa_mese;
  real           _totale_doc, _credito;
  TString        _codreg, _desc_lib, _codatt, _attivita, _tipoatt;
  TString        _tipodoc, _descr_doc, _codlib, _codice_vidi;
  TString        _cofi,_cap,_paiva,_ragsoc,_comunefis,_provfis,_viafis;

protected:  
  const char*   desc_attivita ();
  const char*   tipo_attivita ();
  const char*   descr_doc ();
  const char*   descr_iva (const char *);     
  TRectype&     ricerca_occ(const char*);
  TRectype&     ricerca_cf (char, long);
  TRectype&     look_comuni(const char*);
  int           setta_riga (int, const TRigaiva&, real&, real&, real&, real&);
  int           riga_rmoviva();
  bool          set_print(int);
  bool          set_ditte(TMask&);
  bool          compila_reg(const TMask&);
  bool          compila_lib();
  bool          controlla_liquidazione();
  bool          controlla_mov();
  bool          stampo_liquidazione(int); 
  bool          ventilazione(const char*);
  bool          cerca_libro_gio(TString&);
  bool          look_reg (long, int, TString&, int, const char*, int*);
  bool          look_regs(int, TString&, int, int*);
  bool          stampa_totali_finali();     
  bool          stampa_datareg();
  bool          stampa_registri_IVA(const TMask&);
  void          cerca_reg(const TString&, byte*);
  void          set_page_tot_reg();
  void          send_message(char, const TFilename&,int);
  void          aggiorna_reg();
  void          aggiorna_lib();
  void          calcola_progressivi(); 
  bool          user_create();
  bool          user_destroy();
  bool          preprocess_page(int, int);
  int           stampa_intestazione();
  int           stampa_prospetto();
  void          stampa_plafonds(int);
  void          get_dati_ditta();
  void          stampa_vidi();
  int           stampa_acquisti(int);
  real          stampa_valori_plafonds(const real&, const int, TTable&);
  bool          preprocess_print(int, int);
  //print_action  postprocess_print(int, int);
  print_action  postprocess_page (int, int);
  void          preprocess_header();  

  static bool filter_func (const TRelation * r);

  static bool mask_tipo_stampa (TMask_field&, KEY);
  static bool mask_firm_to     (TMask_field&, KEY);
  static bool mask_cod         (TMask_field&, KEY);
  static bool mask_libun       (TMask_field&, KEY);
  static bool mask_data        (TMask_field&, KEY);
  static bool mask_mese        (TMask_field&, KEY);
  static bool mask_fino_a_mese (TMask_field&, KEY); 
  static bool mask_select      (TMask_field&, KEY);
  static bool mask_azzera      (TMask_field&, KEY);

public:
  
  CG4400_application() : TPrintapp(), _ditte(NULL) {}
  virtual ~CG4400_application() {}
};




