#include <applicat.h>
#include <mask.h>
#include <tabutil.h>

class Visliq_app : public TApplication
{

  TString   _freqviva;  
  int       _year;                    
  
  TTable*    _lim;  
  TTable*    _lia;  
  TTable*    _del;  

  TRectype*  _lim_r;
  TRectype*  _del_r;
  TRecfield* _del_ditta;
  TRecfield* _del_anno;
  TRecfield* _del_mese;
  TRecfield* _del_tipo;
  TRecfield* _lim_anno;
  TRecfield* _lim_mese;

  TMask*     _mask;

  const char* itoname(int m);
  
  bool is_trim(int x); 
  bool is_month_ok(int x, int month = -1);
  
  void set_risultato(TViswin*, long, real&);
  
protected:

  virtual bool menu(MENU_TAG);                              
  virtual bool create(); 
  virtual bool destroy(); 
  
  // handlers             
  static bool set_ditta(TMask_field&, KEY);
  static bool set_anno (TMask_field&, KEY);
  static bool sel_mese_sh1 (TMask_field&, KEY);
  static bool sel_mese_sh2 (TMask_field&, KEY);

  static const char* link_handler(TMask&, int, const char*, bool doubleclick);

  static bool sheet_action(int r, KEY k);

public:           

  bool look_lia(int year = 0);       
  bool look_lim(int m);
  bool look_del(int month, int type);
  
  void set_freqviva();                          
  void set_mask_freq(TMask&);
  void set_year(int y)        { _year = y; }
  
  TMask* get_main_mask()      { return _mask; }
  void update_sheet_row(TToken_string& t);
  
  // workhorses
  bool vis_liq();
  bool vis_all();
  bool vis_one(int);
  
  Visliq_app() : TApplication() {}
  virtual ~Visliq_app() {}
};

